package Reader::itcpm;

require 5.001;

use strict;
use FileHandle;
use Time::Local;


sub new
{
    my ($this, @files) = @_;
    my  $class = ref($this) || $this;
    my  $self = {};

    bless($self, $class);

    print "new Reader::itcpm\n" if( $main::dl>1 );
    @files = sort { ((stat($a))[2]) <=> ((stat($b))[2]) } @files;
    print "  (sorted) files are: ".join(" ",@files)."\n" if( $main::dl>2 );
    $self->{"fh"} = FileHandle->new();
    $self->{"open"} = 0;
    $self->{"files"} = \@files;
    $self->{"header"} = {};
    return($self);
}


sub DESTROY {
    my( $self ) = @_;

    print "Destroy Reader::bs\n" if( $main::dl>1 );
    close( $self->{"fh"} ) if( $self->{"open"} );
}


sub get {
    my( $self ) = @_;
    my $fh = $self->{"fh"};
    my( $item, $when, $oldstatus, $newstatus );
    my( $former, $formerwhen, $formerstatus );
    my $states = $self->{"states"};

    $self->next_file unless( $self->{"open"} );
    return( $self->flush ) unless( $self->{"open"} );
    while( <$fh> ) {
	chomp;
	s/\x0d//g;
	if( /\x0c/ ) {
	    return( $self->flush );
	}
	if( /^([a-z_]+):[\s\t]+(.*)$/i ) {
	    $self->{"header"}->{$1} = $2;
	}
    }
    return();
}



sub flush {
    my( $self ) = @_;
    my $states = $self->{"states"};
    my( @ret, $item, $state, $when, $to, $log );
    my( $i );

    unless( ($i=$self->{"header"}) && keys %$i ) {
	return( );
    }
    @ret = ();
    $item = $self->{"header"}->{"System"};
    $item =~ s/[\s\t].*$//;
    $item = "itcpm-$item";
    $state = 0;
    $when = $self->notestime2unix( $self->{"header"}->{"fromdate"} );
    $to = $self->notestime2unix( $self->{"header"}->{"tilldate"} );
    $log = $self->{"header"}->{"Topic"};
#    if( $when<$to ) {
	push( @ret, [ $item, $state, $when, $to, $log ] );
#    }
    $self->{"header"} = {};
    return( @ret );
}



sub notestime2unix {
    my( $self, $time ) = @_;

    unless( $time =~ /^(\d+)\/(\d+)\/(\d+) (\d+):(\d+):(\d+) (am|pm)/i ) {
	return -1;
    }
    my( $month, $day, $year, $hour, $min, $sec, $m ) = ( $1, $2, $3, $4, $5, $6, $7 );
    unless( length($year)>2 ) {
	# Paede Enggist told me we can rely on 2000 being "2000"
	$year = "19".$year;
    }
    if( ($m =~ /pm/i) && ($hour<12) ) {
	$hour += 12;
    }
    my $utime = timelocal( $sec, $min, $hour, $day, $month-1, $year );
    return $utime;
}


sub next_file {
    my( $self ) = @_;
    my $fh = $self->{"fh"};
    my $files = $self->{"files"};

    print "Reader::bs->next_file()\n" if( $main::dl>2 );
    if( $self->{"open"} ) {
	close $fh;
	$self->{"open"} = 0;
    }
    return unless @$files;
    my $file = shift @$files;
    print "  opening $file\n" if( $main::dl>2 );
    open( $fh, "<$file" ) && ($self->{"open"} = 1);
}

1;

