package Reader::pagerlog;

require 5.001;

use strict;
use FileHandle;

my %numstatus = (
    "green", 3,
    "purple", 2,
    "yellow", 1,
    "red", 0
    );


sub new
{
    my ($this, @files) = @_;
    my  $class = ref($this) || $this;
    my  $self = {};

    bless($self, $class);

    print "new Reader::bs\n" if( $main::dl>1 );
    @files = sort { ((stat($a))[2]) <=> ((stat($b))[2]) } @files;
    print "  (sorted) files are: ".join(" ",@files)."\n" if( $main::dl>2 );
    $self->{"fh"} = FileHandle->new();
    $self->{"open"} = 0;
    $self->{"files"} = \@files;
    $self->{"states"} = {};
    return($self);
}


sub DESTROY {
    my( $self ) = @_;

    print "Destroy Reader::bs\n" if( $main::dl>1 );
    close( $self->{"fh"} ) if( $self->{"open"} );
}


sub get {
    my( $self ) = @_;
    my $fh = $self->{"fh"};
    my( $item, $when, $oldstatus, $newstatus, $txt );
    my( $former, $formerwhen, $formerstatus );
    my $states = $self->{"states"};

    $self->next_file unless( $self->{"open"} );
    return( $self->flush ) unless( $self->{"open"} );
    if( $_ = <$fh> ) {
	chomp;
	s/
//g;
	/HOSTNAME ([^\s\t]+).*TIME ([\d]+)..(.*)$/;
	($item, $when, $txt) = ($1,$2,$3);
	if( $txt =~ /down/i ) {
	    $newstatus = 0;
	}
	elsif( $txt =~ /Up/i ) {
	    $newstatus = 3;
	}
	else {
	    return( $self->get );
	}
	if( $$states{$item} ) {
	    $former = $$states{$item};
	    ($formerstatus,$formerwhen) = @$former;
	}
	else {
	    $formerstatus = 3;
	    $formerwhen = 0;
	}
	print "    adding $txt: from $formerwhen to $when: status $formerstatus->$newstatus\n" if( ($main::dl>4) && ($item eq "gw-bu-bu") );
	$$states{$item} = [ $newstatus, $when, $_ ];
	return( [ $item, $formerstatus, $formerwhen, $when, $_ ] );
    }
    else {
	$self->next_file;
	return $self->get;
    }
}



sub flush {
    my( $self ) = @_;
    my $states = $self->{"states"};
    my( @ret, $item, $state, $when, $log );
    my( $i );

    unless( $self->{"states"} ) {
	return( );
    }
    @ret = ();
    while( ($item,$i) = each %$states ) {
	($state,$when,$log) = @$i;
	push( @ret, [ $item, $state, $when, time, $log ] );
    }
    delete $self->{"states"};
    return( @ret );
}


sub next_file {
    my( $self ) = @_;
    my $fh = $self->{"fh"};
    my $files = $self->{"files"};

    print "Reader::bs->next_file()\n" if( $main::dl>2 );
    if( $self->{"open"} ) {
	close $fh;
	$self->{"open"} = 0;
    }
    return unless @$files;
    my $file = shift @$files;
    print "  opening $file\n" if( $main::dl>2 );
    open( $fh, "<$file" ) && ($self->{"open"} = 1);
}

1;

