package Stat::stat;

require 5.001;

use strict;
use FileHandle;

sub new
{
    my ($this) = @_;
    my  $class = ref($this) || $this;
    my  $self = {};

    bless($self, $class);

    $self->{"hist"} = {};
    $self->{"prefix"} = "";
    return($self);
}


sub prefix {
    my( $self, $prefix ) = @_;

    $self->{"prefix"} = $prefix;
}


sub put {
    my( $self, @stats ) = @_;
    my( $stat );

    foreach $stat (@stats) { $self->put_one($stat); }
}


sub put_one {
    my( $self, $stat ) = @_;
    my( $item, $status, $fromwhen, $towhen, $comment );
    my( $hist, $i, $curr );

    print "    Stat::stat->put_one()\n" if( $main::dl>5 );
    ($item, $status, $fromwhen, $towhen, $comment) = @$stat;
    $item = ($self->{"prefix"}).$item;
    $$stat[0] = $item;
    print "      $item $status from: ".localtime($fromwhen)." to: ".localtime($towhen)."  $comment\n" if( $main::dl>6 );
    unless( defined $self->{"hist"}->{$item} ) {
	$self->{"hist"}->{$item} = [];
    }
    $hist = $self->{"hist"}->{$item};
    for( $i=$#$hist; $i>=0; $i-- ) {
	$curr = $$hist[$i];
	print "        compare to $$curr[0] $$curr[1] from: ".localtime($$curr[2])." to: ".localtime($$curr[3])."  $$curr[4]\n" if( $main::dl>10 );
	if( $fromwhen >= $$curr[3] ) {
	    # just behind everything else
	    print "        just behind everything\n" if( $main::dl>10 );
	    splice( @$hist, $i+1, 0, $stat );
	    return;
	}
	elsif( $fromwhen > $$curr[2] ) {
	    # overlapping with 'curr'
	    print "        overlapping\n" if( $main::dl>10 );
	    my $oldto = $$curr[3];
	    $$curr[3] = $fromwhen;
	    splice( @$hist, $i+1, 0, $stat );
	    if( $towhen < $oldto ) {
		print "        but inside\n" if( $main::dl>10 );
		# inside 'curr'
		splice( @$hist, $i+2, 0, [ $item, $$curr[1], $towhen, $oldto, $$curr[4] ] );
	    }
	    return;
	}
	elsif( ($fromwhen <= $$curr[2]) && ($towhen >= $$curr[3]) ) {
	    # completely replacing 'curr'
	    print "        replacing\n" if( $main::dl>10 );
	    splice( @$hist, $i, 1 );
	}
	elsif( ($fromwhen <= $$curr[2]) && ($towhen < $$curr[3]) && ($towhen > $$curr[2]) ) {
	    print "        pushing lower edge\n" if( $main::dl>10 );
	    $$curr[2] = $towhen;
	}
    }
    splice( @$hist, 0, 0, $stat );
}



sub optimize {
    my( $self, $group ) = @_;
    my( $ref, $i, $a, $b );

    $ref = $self->{"hist"}->{$group};
    return unless( $ref );
    for( $i=0; $i<$#$ref; ) {
	$a = $$ref[$i];
	$b = $$ref[$i+1];
	if( ($$a[1] eq $$b[1]) && ($$a[3] == $$b[2]) ) {
	    $$a[3] = $$b[3];
	    splice( @$ref, $i+1, 1 );
	}
	else {
	    $i++;
	}
    }
}
1;
